## ompl 1.4.2+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
cmake_policy(SET CMP0017 NEW)
if(NOT ${CMAKE_VERSION} VERSION_LESS 3.0.0)
    cmake_policy(SET CMP0042 NEW)
endif()
project(ompl CXX C)

# set the default build type
if (NOT CMAKE_BUILD_TYPE)
    # By default, use Release mode
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Type of build" FORCE)

    # On 32bit architectures, use RelWithDebInfo
    if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Type of build" FORCE)
    endif()
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE}")

# This shouldn't be necessary, but there has been trouble
# with MSVC being set off, but MSVCXX ON.
if(MSVC OR MSVC90 OR MSVC10)
    set(MSVC ON)
endif (MSVC OR MSVC90 OR MSVC10)

set(CMAKE_MODULE_PATH
    "${CMAKE_MODULE_PATH}"
    "${CMAKE_ROOT_DIR}/cmake/Modules"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(GNUInstallDirs)
include(FeatureSummary)
include(CompilerSettings)
include(OMPLVersion)
include(OMPLUtils)

set(EXECUTABLE_OUTPUT_PATH "${PROJECT_BINARY_DIR}/bin")
set(LIBRARY_OUTPUT_PATH "${PROJECT_BINARY_DIR}/lib")

set(OMPL_CMAKE_UTIL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules"
    CACHE FILEPATH "Path to directory with auxiliary CMake scripts for OMPL")
set(OMPL_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")
set(OMPL_DEMO_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/ompl/demos"
    CACHE STRING "Relative path to directory where demos will be installed")

include_directories("${OMPL_INCLUDE_DIR}")

if(MSVC)
    add_definitions(-DBOOST_ALL_NO_LIB)
    add_definitions(-DBOOST_PROGRAM_OPTIONS_DYN_LINK)
endif(MSVC)
if(IS_ICPC)
    set(Boost_USE_STATIC_LIBS ON CACHE STRING "Use statically linked Boost libraries")
else(IS_ICPC)
    # Ensure dynamic linking with boost unit_test_framework
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif(IS_ICPC)

set_package_properties(Boost PROPERTIES
    URL "http://boost.org"
    PURPOSE "Used throughout OMPL for data serialization, graphs, etc.")
find_package(Boost 1.54 QUIET REQUIRED COMPONENTS serialization filesystem system program_options)
include_directories(${Boost_INCLUDE_DIR})

# Add support in Boost::Python for std::shared_ptr
# This is a hack that replaces boost::shared_ptr related code with std::shared_ptr.
# Proper support for std::shared_ptr was added in Boost 1.63.
if(Boost_VERSION VERSION_LESS "106300")
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/src/external")
endif()


# on macOS we need to check whether to use libc++ or libstdc++ with clang++
if(APPLE AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    include(GetPrerequisites)
    get_prerequisites("${Boost_SYSTEM_LIBRARY}" _libs 0 0 "/" "")
    set(CXXSTDLIB "")
    foreach(_lib ${_libs})
        if(_lib MATCHES "libc\\+\\+")
            set(CXXSTDLIB "libc++")
        elseif(_lib MATCHES "libstdc\\+\\+")
            set(CXXSTDLIB "libstdc++")
        endif()
    endforeach()
    if(CXXSTDLIB)
        add_definitions(-stdlib=${CXXSTDLIB})
    endif()
endif()

set_package_properties(Threads PROPERTIES
    URL "https://en.wikipedia.org/wiki/POSIX_Threads"
    PURPOSE "Pthreads is sometimes needed, depending on OS / compiler.")
find_package(Threads QUIET)

enable_testing()

set_package_properties(Python PROPERTIES
    URL "http://python.org"
    PURPOSE "Used for python bindings.")
find_package(Python QUIET)
find_boost_python()

if(PYTHON_FOUND)
    set_package_properties(pypy PROPERTIES
        URL "http://pypy.org"
        PURPOSE "Used to speed up the generation of python bindings.")
    find_package(pypy QUIET)
endif()

set_package_properties(Eigen3 PROPERTIES
    URL "http://eigen.tuxfamily.org"
    PURPOSE "A linear algebra library used throughout OMPL.")
find_package(Eigen3 REQUIRED)
include_directories("${EIGEN3_INCLUDE_DIR}")

set_package_properties(MORSE PROPERTIES
    URL "https://www.openrobots.org/wiki/morse"
    PURPOSE "OMPL includes a plugin for the MORSE Robot Simulation engine.")
find_package(MORSE QUIET)
set(OMPL_EXTENSION_MORSE ${MORSE_FOUND})

set_package_properties(OpenDE PROPERTIES
    URL "http://ode.org"
    PURPOSE "The Open Dynamics Engine can be used as a \"black box\" for kinodynamic planning.")
find_package(OpenDE QUIET)
set(OMPL_EXTENSION_OPENDE ${OPENDE_FOUND})
if (OPENDE_FOUND)
  add_definitions(${OPENDE_DEFINITIONS})
  include_directories(${OPENDE_INCLUDE_DIR})
endif()

set_package_properties(Triangle PROPERTIES
    URL "http://www.cs.cmu.edu/~quake/triangle.html"
    PURPOSE "Used to create triangular decompositions of polygonal 2D environments.")
find_package(Triangle QUIET)
set(OMPL_EXTENSION_TRIANGLE ${TRIANGLE_FOUND})
if (TRIANGLE_FOUND)
  include_directories(${TRIANGLE_INCLUDE_DIR})
endif()

set_package_properties(flann PROPERTIES
    URL "https://github.com/mariusmuja/flann"
    PURPOSE "If detetected, FLANN can be used for nearest neighbor queries by OMPL.")
find_package(flann 1.8.3 QUIET)
if (FLANN_FOUND)
    set(OMPL_HAVE_FLANN 1)
    include_directories("${FLANN_INCLUDE_DIRS}")
    link_directories(${FLANN_LIBRARY_DIRS})
endif()

set_package_properties(spot PROPERTIES
    URL "http://spot.lrde.epita.fr"
    PURPOSE "Used for constructing finite automata from LTL formulae.")
find_package(spot)
if (SPOT_FOUND)
    set(OMPL_HAVE_SPOT 1)
    include_directories("${SPOT_INCLUDE_DIRS}")
    link_directories(${SPOT_LIBRARY_DIRS})
endif()

# Numpy is used to convert Eigen matrices/vectors to numpy arrays
if(PYTHON_FOUND AND NOT Boost_VERSION VERSION_LESS "106300")
    find_python_module(numpy)
    if (PY_NUMPY)
        find_boost_numpy()
        if(Boost_NUMPY_LIBRARY)
            set(OMPL_HAVE_NUMPY 1)
            include_directories("${PY_NUMPY}/core/include")
        endif()
    endif()
endif()

# R is needed for running Planner Arena locally
find_program(R_EXEC R)

add_subdirectory(py-bindings)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(demos)
add_subdirectory(scripts)
add_subdirectory(doc)

target_link_flags(ompl)
set(PKG_NAME "ompl")
set(PKG_DESC "The Open Motion Planning Library")
set(PKG_EXTERNAL_DEPS "${ompl_PKG_DEPS}")
set(PKG_OMPL_LIBS "-lompl ${ompl_LINK_FLAGS}")
set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/ompl.pc")
configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)
install(FILES "${pkg_conf_file}"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
  COMPONENT ompl
  RENAME "ompl.pc")

if (NOT ${CMAKE_VERSION} VERSION_LESS 2.8.8)
    include(CMakePackageConfigHelpers)
    set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
    set(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
    configure_package_config_file(omplConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/omplConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/ompl/cmake
        PATH_VARS INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
        NO_CHECK_REQUIRED_COMPONENTS_MACRO)
    write_basic_package_version_file(
        ${CMAKE_CURRENT_BINARY_DIR}/omplConfigVersion.cmake
        VERSION ${OMPL_VERSION}
        COMPATIBILITY SameMajorVersion)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/omplConfig.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/omplConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/ompl/cmake
        COMPONENT ompl)
endif()

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/ompl.conf"
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ompl"
  COMPONENT ompl)

# script to install ompl on Ubuntu
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/install-ompl-ubuntu.sh.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/install-ompl-ubuntu.sh" @ONLY)

# uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

include(CPackSettings)

option(OMPL_REGISTRATION "Enable one-time registration of OMPL" ON)
if (OMPL_REGISTRATION)
    find_file(OMPL_REGISTERED ".registered" PATHS "${CMAKE_CURRENT_SOURCE_DIR}" NO_DEFAULT_PATH)
    if (NOT OMPL_REGISTERED)
        file(WRITE "${CMAKE_CURRENT_SOURCE_DIR}/.registered" "")
        find_package(Python QUIET)
        if (PYTHON_FOUND)
            execute_process(COMMAND "${PYTHON_EXEC}" "-m" "webbrowser" "http://ompl.kavrakilab.org/core/register.html"
                OUTPUT_QUIET ERROR_QUIET)
        endif()
    endif()
endif()

# needed for ROS installation
if (EXISTS "package.xml")
    # install catkin package.xml
    install(FILES package.xml DESTINATION "share/ompl")
endif()

set_package_properties(PkgConfig PROPERTIES
    URL "https://www.freedesktop.org/wiki/Software/pkg-config/"
    PURPOSE "Used to find (compilation flags for) dependencies.")
set_package_properties(castxml PROPERTIES
    URL "https://github.com/CastXML/CastXML"
    PURPOSE "Used to generate Python bindings.")
feature_summary(DESCRIPTION INCLUDE_QUIET_PACKAGES WHAT ALL)
# additional feature info: show which Python modules were found and weren't found
get_property(PY_MODULES_FOUND GLOBAL PROPERTY PY_MODULES_FOUND)
if(PY_MODULES_FOUND)
    list(REMOVE_DUPLICATES PY_MODULES_FOUND)
    string(REPLACE ";" " " PY_MODULES_FOUND_STR "${PY_MODULES_FOUND}")
    message(STATUS "The following Python modules were found:\n\n * ${PY_MODULES_FOUND_STR}\n")
endif()
get_property(PY_MODULES_NOTFOUND GLOBAL PROPERTY PY_MODULES_NOTFOUND)
if(PY_MODULES_NOTFOUND)
    list(REMOVE_DUPLICATES PY_MODULES_NOTFOUND)
    string(REPLACE ";" " " PY_MODULES_NOTFOUND_STR "${PY_MODULES_NOTFOUND}")
    message(STATUS "The following Python modules were NOT found:\n\n * ${PY_MODULES_NOTFOUND_STR}\n")
endif()

=== demos/CMakeLists.txt ===
option(OMPL_BUILD_DEMOS "Build OMPL demos" ON)
add_feature_info(OMPL_BUILD_DEMOS "${OMPL_BUILD_DEMOS}" "Whether to build the OMPL demo programs.")

if (OMPL_BUILD_DEMOS)

  macro(add_ompl_demo demo_name)
    add_executable(${ARGV})
    target_link_libraries(${demo_name}
      ompl
      ${Boost_FILESYSTEM_LIBRARY}
      ${Boost_SYSTEM_LIBRARY}
      ${Boost_PROGRAM_OPTIONS_LIBRARY})
  endmacro(add_ompl_demo)

  add_ompl_demo(demo_RigidBodyPlanning RigidBodyPlanning.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIK RigidBodyPlanningWithIK.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithControls RigidBodyPlanningWithControls.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIntegrationAndControls RigidBodyPlanningWithIntegrationAndControls.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithODESolverAndControls RigidBodyPlanningWithODESolverAndControls.cpp)
  add_ompl_demo(demo_StateSampling StateSampling.cpp)
  add_ompl_demo(demo_GeometricCarPlanning GeometricCarPlanning.cpp)
  add_ompl_demo(demo_Point2DPlanning Point2DPlanning.cpp)
  add_ompl_demo(demo_HybridSystemPlanning HybridSystemPlanning.cpp)
  add_ompl_demo(demo_KinematicChainBenchmark KinematicChainBenchmark.cpp)
  add_ompl_demo(demo_HypercubeBenchmark HypercubeBenchmark.cpp)
  aux_source_directory(Koules Koules_SRC)
  add_ompl_demo(demo_Koules ${Koules_SRC})
  add_ompl_demo(demo_PlannerData PlannerData.cpp)
  add_ompl_demo(demo_ThunderLightning ThunderLightning.cpp)


  add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)
  add_ompl_demo(demo_PlannerProgressProperties PlannerProgressProperties.cpp)
  add_ompl_demo(demo_CForestCircleGridBenchmark CForestCircleGridBenchmark.cpp)

  add_ompl_demo(demo_Diagonal Diagonal.cpp)

  add_ompl_demo(demo_VectorFieldConservative VFRRT/VectorFieldConservative.cpp)
  add_ompl_demo(demo_VectorFieldNonconservative VFRRT/VectorFieldNonconservative.cpp)

  add_ompl_demo(demo_ConstrainedPlanningSphere constraint/ConstrainedPlanningSphere.cpp)
  add_ompl_demo(demo_ConstrainedPlanningTorus constraint/ConstrainedPlanningTorus.cpp)
  add_ompl_demo(demo_ConstrainedPlanningImplicitChain constraint/ConstrainedPlanningImplicitChain.cpp)
  add_ompl_demo(demo_ConstrainedPlanningImplicitParallel constraint/ConstrainedPlanningImplicitParallel.cpp)
  add_ompl_demo(demo_ConstrainedPlanningKinematicChain constraint/ConstrainedPlanningKinematicChain.cpp)

  if (OMPL_EXTENSION_OPENDE)
    add_ompl_demo(demo_OpenDERigidBodyPlanning OpenDERigidBodyPlanning.cpp)
  endif()

  if (OMPL_EXTENSION_TRIANGLE)
    add_ompl_demo(demo_TriangulationDemo TriangulationDemo.cpp)
    add_ompl_demo(demo_LTLWithTriangulation LTLWithTriangulation)
  endif()


endif(OMPL_BUILD_DEMOS)

file(GLOB OMPL_DEMO_PY_FILES "*.py")
install_python(PROGRAMS ${OMPL_DEMO_PY_FILES}
  DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
  COMPONENT ompl)
file(GLOB OMPL_DEMO_CXX_FILES "*.cpp")
install(FILES ${OMPL_DEMO_CXX_FILES}
    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
    COMPONENT ompl)
install(DIRECTORY Koules
    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
    COMPONENT ompl)
install(DIRECTORY VFRRT
    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
    COMPONENT ompl)

=== py-bindings/CMakeLists.txt ===
include(PythonBindingsUtils)
if(PY_PYPLUSPLUS AND PY_PYGCCXML AND CASTXML_FOUND)
    option(OMPL_BUILD_PYBINDINGS "Build OMPL Python bindings" ON)
    option(OMPL_BUILD_PYTESTS "Build/run OMPL Python tests" ON)
else()
    option(OMPL_BUILD_PYBINDINGS "Build OMPL Python bindings" OFF)
    option(OMPL_BUILD_PYTESTS "Build/run OMPL Python tests" OFF)
endif()
add_feature_info(OMPL_BUILD_PYBINDINGS "${OMPL_BUILD_PYBINDINGS}" "Whether to build the Python bindings.")
add_feature_info(OMPL_BUILD_PYTESTS "${OMPL_BUILD_PYTESTS}" "Whether to build/run the python binding unit tests.")

if (OMPL_BUILD_PYBINDINGS)
    if(WIN32)
        # omit StateStorage class bindings on Windows;
        # Boost.Serialization does nasty things that break the bindings.
        set(PYOMPL_EXTRA_CFLAGS "${PYOMPL_EXTRA_CFLAGS} -DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_")
        add_definitions(-DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_)
    endif(WIN32)

    set(OMPL_MODULES base control geometric tools util)
    if(OMPL_EXTENSION_MORSE)
        list(APPEND OMPL_MODULES morse)
    endif()

    if(PY_OMPL_GENERATE)
        # need to run cmake to regenerate ompl/bindings_generator.py if
        # bindings_generator.py.in is changed.
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/bindings_generator.py.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/ompl/bindings_generator.py" @ONLY)

        create_module_generation_targets(util)
        if(OMPL_HAVE_NUMPY)
            create_module_generation_targets(base)
        else()
            create_module_generation_targets(base "[Cc]onstrain")
        endif()
        create_module_generation_targets(geometric)
        create_module_generation_targets(control)
        create_module_generation_targets(tools)
        if(OMPL_EXTENSION_MORSE)
            create_module_generation_targets(morse)
        endif()

        add_dependencies(update_base_bindings update_util_bindings)
        add_dependencies(update_geometric_bindings update_base_bindings)
        add_dependencies(update_control_bindings update_geometric_bindings)
        add_dependencies(update_control_bindings update_base_bindings)
        add_dependencies(update_tools_bindings update_control_bindings)
        if(OMPL_EXTENSION_MORSE)
            add_dependencies(update_morse_bindings update_base_bindings)
            add_dependencies(update_morse_bindings update_control_bindings)
        endif()
    endif(PY_OMPL_GENERATE)

    if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/bindings")
        foreach(module ${OMPL_MODULES})
            create_module_target(${module})
        endforeach(module)
        if(OMPL_HAVE_NUMPY AND TARGET py_ompl_base)
            target_link_libraries(py_ompl_base ${Boost_NUMPY_LIBRARY})
        endif()

        install(DIRECTORY ompl DESTINATION "${OMPL_PYTHON_INSTALL_DIR}"
            COMPONENT python
            PATTERN "*.pyc" EXCLUDE
            PATTERN "__pycache__" EXCLUDE
            PATTERN "_*.so" EXCLUDE
            PATTERN "app" EXCLUDE
            PATTERN "morse" EXCLUDE)
        # put app submodule in omplapp component
        if(OMPLAPP_VERSION)
            install(DIRECTORY ompl/app
                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
                COMPONENT omplapp
                PATTERN "*.pyc" EXCLUDE
                PATTERN "__pycache__" EXCLUDE
                PATTERN "_*.so" EXCLUDE)
        endif()
        # put morse submodule in morse component
        if(OMPL_EXTENSION_MORSE)
            install(DIRECTORY ompl/morse
                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
                COMPONENT morse
                PATTERN "*.pyc" EXCLUDE
                PATTERN "__pycache__" EXCLUDE
                PATTERN "_*.so" EXCLUDE
                PATTERN "addons" EXCLUDE)
            # blender add-on
            install(DIRECTORY ompl/morse/addons
                DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ompl"
                COMPONENT morse
                PATTERN "*.pyc" EXCLUDE)
        endif()
    endif()

endif(OMPL_BUILD_PYBINDINGS)

add_custom_target(clean_bindings
    "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/bindings"
    COMMAND "${CMAKE_COMMAND}" -E remove -f pyplusplus_{base,control,geometric,tools,util}.{cache,log}
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")

=== src/CMakeLists.txt ===
add_subdirectory(ompl)
install(DIRECTORY ompl/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ompl"
    COMPONENT ompl
    FILES_MATCHING PATTERN "*.h"
    PATTERN ".DS_Store" EXCLUDE
    PATTERN "sample_contrib" EXCLUDE
    REGEX "/src$" EXCLUDE
    REGEX "/doc$" EXCLUDE
    REGEX "/tests$" EXCLUDE)

=== tests/CMakeLists.txt ===
find_package(Boost 1.54 QUIET COMPONENTS unit_test_framework)
if(Boost_UNIT_TEST_FRAMEWORK_LIBRARY)
    option(OMPL_BUILD_TESTS "Build OMPL tests" ON)
else()
    option(OMPL_BUILD_TESTS "Build OMPL tests" OFF)
endif()
add_feature_info(OMPL_BUILD_TESTS "${OMPL_BUILD_TESTS}" "Whether to build the unit tests.")

# configure location of resources (which are used by some demos, so this needs
# to be outside of if-statement below)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
if(WIN32)
    # Correct directory separator for Windows
    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR "${TEST_RESOURCES_DIR}")
endif(WIN32)
configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")

if (OMPL_BUILD_TESTS)
    # Test datastructures implementation
    add_ompl_test(test_heap datastructures/heap.cpp)
    add_ompl_test(test_grid datastructures/grid.cpp)
    add_ompl_test(test_gridb datastructures/gridb.cpp)
    add_ompl_test(test_nearestneighbors datastructures/nearestneighbors.cpp)
    if(FLANN_FOUND)
        target_link_libraries(test_nearestneighbors ${FLANN_LIBRARIES})
    endif()
    add_ompl_test(test_pdf datastructures/pdf.cpp)

    # Test utilities
    add_ompl_test(test_random util/random/random.cpp)
    # optimization flags make this test fail
    if (CMAKE_BUILD_TYPE STREQUAL "Debug")
        add_ompl_test(test_machine_specs benchmark/machine_specs.cpp)
    endif()

    # Test base code
    add_ompl_test(test_state_operations base/state_operations.cpp)
    add_ompl_test(test_state_spaces base/state_spaces.cpp)
    add_ompl_test(test_state_storage base/state_storage.cpp)
    add_ompl_test(test_ptc base/ptc.cpp)
    add_ompl_test(test_planner_data base/planner_data.cpp)

    # Test kinematic motion planners in 2D environments
    add_ompl_test(test_2denvs_geometric geometric/2d/2denvs.cpp)
    add_ompl_test(test_2dmap_geometric_simple geometric/2d/2dmap_simple.cpp)
    add_ompl_test(test_2dmap_ik geometric/2d/2dmap_ik.cpp)
    add_ompl_test(test_2dcircles_opt_geometric geometric/2d/2dcircles_optimize.cpp)
    add_ompl_test(test_2dpath_simplifying geometric/2d/2dpath_simplifying.cpp)

    # Test constrained planning
    add_ompl_test(test_constraint_sphere geometric/constraint/test_sphere.cpp)

    # Test planning with controls on a 2D map
    add_ompl_test(test_2dmap_control control/2dmap/2dmap.cpp)
    add_ompl_test(test_planner_data_control control/planner_data.cpp)

    # Test planning via MORSE extension
    if(OMPL_EXTENSION_MORSE)
        add_ompl_test(test_morse_extension extensions/morse/morse_plan.cpp)
    endif(OMPL_EXTENSION_MORSE)

    # Python unit tests
    if(PYTHON_FOUND AND OMPL_BUILD_PYTESTS)
        if (EXISTS "${CMAKE_CURRENT_BINARY_DIR}/../py-bindings/bindings")
            add_ompl_python_test(util/test_util.py)
            add_ompl_python_test(base/test_base.py)
            add_ompl_python_test(geometric/test_geometric.py)
            add_ompl_python_test(geometric/test_geometric_compoundstate.py)
            add_ompl_python_test(control/test_control.py)
        endif()

        # test the python function to std::function conversion utility functions
        include_directories(${PYTHON_INCLUDE_DIRS})
        add_library(py_std_function MODULE util/test_py_std_function.cpp)
        target_link_libraries(py_std_function ompl ${Boost_PYTHON_LIBRARY} ${PYTHON_LIBRARIES})
        if(WIN32)
            set_target_properties(py_std_function PROPERTIES OUTPUT_NAME py_std_function SUFFIX .pyd)
        endif(WIN32)
        add_custom_command(TARGET py_std_function POST_BUILD
            COMMAND "${CMAKE_COMMAND}" -E copy "$<TARGET_FILE:py_std_function>"
            "${CMAKE_CURRENT_SOURCE_DIR}/util"
            WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
        add_ompl_python_test(util/test_py_std_function.py)
    endif()

    add_subdirectory(regression_tests)
endif()

=== src/ompl/CMakeLists.txt ===
#############################################
# Construct configuration file              #
#############################################

file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" VERSION_DIR)
configure_file("${VERSION_DIR}/config.h.in" "${VERSION_DIR}/config.h")


#############################################
# recursively find all *.cpp files that     #
# correspond to the basic ompl library      #
#############################################
file(GLOB_RECURSE OMPL_SOURCE_CODE datastructures/*.cpp util/*.cpp base/*.cpp geometric/*.cpp control/*.cpp tools/*.cpp)

#############################################
# Add enabled extensions to the source code #
#############################################

## replace XXX by the extension
#if (OMPL_EXTENSION_XXX)
#    file(GLOB_RECURSE OMPL_XXX_EXTENSION_SOURCE_CODE extensions/XXX/*.cpp)
#    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_XXX_EXTENSION_SOURCE_CODE})
#
##    if additional libraries need to be linked, they are added to manifest.xml for ROS
##    or they are added to the list of OMPL_LINK_LIBRARIES
#
#endif()

if (OMPL_EXTENSION_MORSE)
    file(GLOB_RECURSE OMPL_MORSE_EXTENSION_SOURCE_CODE extensions/morse/*.cpp)
    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_MORSE_EXTENSION_SOURCE_CODE})
endif()

if (OMPL_EXTENSION_OPENDE)
    file(GLOB_RECURSE OMPL_OPENDE_EXTENSION_SOURCE_CODE extensions/opende/*.cpp)
    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_OPENDE_EXTENSION_SOURCE_CODE})
    list(APPEND OMPL_LINK_LIBRARIES "${OPENDE_LIBRARY}")
endif()

if (OMPL_EXTENSION_TRIANGLE)
  file(GLOB_RECURSE OMPL_TRIANGLE_EXTENSION_SOURCE_CODE extensions/triangle/*.cpp)
  set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_TRIANGLE_EXTENSION_SOURCE_CODE})
  list(APPEND OMPL_LINK_LIBRARIES ${TRIANGLE_LIBRARY})
endif()

if (OMPL_HAVE_SPOT)
  set_source_files_properties(control/planners/ltl/src/Automaton.cpp
    PROPERTIES COMPILE_FLAGS -std=c++14)
endif()

#############################################
# Build and install the library             #
#############################################
if(MSVC OR IS_ICPC)
  add_library(ompl STATIC ${OMPL_SOURCE_CODE})
else(MSVC OR IS_ICPC)
  add_library(ompl SHARED ${OMPL_SOURCE_CODE})
endif(MSVC OR IS_ICPC)
target_link_libraries(ompl
  ${OMPL_LINK_LIBRARIES}
  ${Boost_DATE_TIME_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  ${Boost_SERIALIZATION_LIBRARY}
  ${Boost_FILESYSTEM_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_CHRONO_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT})

if (OMPL_HAVE_SPOT)
  target_link_libraries(ompl ${SPOT_LIBRARIES})
endif()

if(MSVC)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" STATIC_LIBRARY_FLAGS "psapi.lib ws2_32.lib")
else(MSVC)
  if (MINGW)
    target_link_libraries(ompl psapi ws2_32)
    set_target_properties(ompl PROPERTIES LINK_FLAGS "-Wl,--export-all-symbols")
  endif(MINGW)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" SOVERSION "${OMPL_ABI_VERSION}")
endif(MSVC)

# install the library
install(TARGETS ompl
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT ompl)
if(NOT MSVC)
    add_custom_command(TARGET ompl POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy "$<TARGET_FILE:ompl>"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../py-bindings/ompl/util/libompl${CMAKE_SHARED_LIBRARY_SUFFIX}"
        WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
endif(NOT MSVC)

=== debian/changelog ===
ompl (1.4.2+ds1-6) unstable; urgency=medium

  * Fix python depends field
  * Added patch to solve find Python 3.8
  * Added patch to fix compilation error with Boost 1.71. Closes: #953873
  * Fix Python 3 stuff
  * Added R³ rule
  * Bump to debhelper 12
  * Bump Standards. No changes
  * Simplify d./rules

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Fri, 05 Jun 2020 11:33:48 +0200

ompl (1.4.2+ds1-5) unstable; urgency=medium

  * Added r-cran-shinyjs, r-cran-v8, r-cran-dbplyr dependencies
    to ompl-plannerarena package.
  * Moves to Python3. Closes: #945678

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 25 Dec 2019 20:42:51 +0100

ompl (1.4.2+ds1-4) unstable; urgency=medium

  * Changed maintainer patch to upstream patch to solve pkg-config bug.
  * Changed libode-dev Suggest in libompl-dev to dependency. Closes: #931000

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 25 Jun 2019 10:21:42 +0200

ompl (1.4.2+ds1-3) unstable; urgency=medium

  * Add a patch to fix the pkg (.pc) file as bug said. Closes: #930507
  * Add a clean rule to delete generated files.
  * Drop CMAKE_INSTALL_LIBDIR parameter. It's obtained by CMAKE.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 17 Jun 2019 15:08:41 +0200

ompl (1.4.2+ds1-2) unstable; urgency=medium

  * Team upload.
  * Remove wrong MA hint (according to hinter)
  * Add missing dependency (Closes: #930507)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 16 Jun 2019 10:34:15 +0200

ompl (1.4.2+ds1-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version to 4.3.0 (no changes)

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 11 Feb 2019 12:55:56 +0100

ompl (1.4.0+ds1-4) unstable; urgency=medium

  * Rebuild version to unstable.
  * Make secure copyright format uri
  * Cleaned trailing whitespace

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sat, 27 Oct 2018 19:49:34 +0200

ompl (1.4.0+ds1-3) experimental; urgency=medium

  * Fixed missing Breaks and Replaces: ompl-demos (<< 1.4). Closes: #909126
    Too much creative syntax :-(

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Thu, 25 Oct 2018 08:40:52 +0200

ompl (1.4.0+ds1-2) experimental; urgency=medium

  * Closes: #909126. Fixed missing Breaks+Replaces: ompl-demos (<< 1.4)

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 19 Sep 2018 17:49:27 +0200

ompl (1.4.0+ds1-1) experimental; urgency=medium

  * New upstream version.
  * Upgrading to the new version of ompl
  * Updating patches
  * Update copyright. Thx decopy
  * Drop old file
  * New package. ompl-plannerarena to test planners.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sat, 08 Sep 2018 18:14:15 +0200

=== debian/control ===
Source: ompl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               cmake,
               dh-exec,
               libboost-date-time-dev,
               libboost-thread-dev,
               libboost-serialization-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               libboost-test-dev,
	       libboost-python-dev,
               libode-dev,
	       libeigen3-dev,
	       pkg-config,
               libflann-dev,
	       r-base-core,
	       dh-python,
	       python3-all
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/ompl
Vcs-Git: https://salsa.debian.org/science-team/ompl.git
Homepage: http://ompl.kavrakilab.org

Package: libompl-dev
Architecture: any
Section: libdevel
Depends: libompl15 (= ${binary:Version}),
         ${misc:Depends},
         libboost-dev,
         libeigen3-dev,
	 libode-dev
Suggests: pkg-config
Description: Open Motion Planning Library (OMPL) development files
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection, and no visualization. The library is designed so
 it can be easily integrated into systems that provide those
 additional components. This package contains the development files
 needed to use the library.

Package: libompl15
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Open Motion Planning Library (OMPL)
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection, and no visualization. The library is designed so
 it can be easily integrated into systems that provide those
 additional components.  This package contains the library itself.

Package: ompl-demos
Multi-Arch: foreign
Architecture: all
Section: science
Depends: ${misc:Depends},
         ${python3:Depends},
         python3,
         python3-matplotlib,
         libompl-dev
Description: Open Motion Planning Library (OMPL) demos
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection or visualization. The library is designed so it
 can be easily integrated into systems that provide the additional
 needed components.  This package contains a set of demos of the
 library.

Package: ompl-plannerarena
Multi-Arch: foreign
Architecture: all
Breaks: ompl-demos (<< 1.4)
Replaces: ompl-demos (<< 1.4)
Section: science
Depends: ${misc:Depends}, r-base-core, r-cran-shiny, r-cran-dplyr,
	r-cran-tidyr, r-cran-ggplot2, r-cran-hmisc, r-cran-rsqlite,
	r-cran-markdown, ruby, r-cran-shinyjs, r-cran-v8, r-cran-dbplyr
Description: Open Motion Planning Library (OMPL) plannerarena
 The Open Motion Planning Library is a set of sampling-based motion
 planning algorithms. The content of the library is limited to these
 algorithms, which means there is no environment specification, no
 collision detection or visualization. The library is designed so it
 can be easily integrated into systems that provide the additional
 needed components.
 .
 This package contains an script that launches a web server locally
 to analyze SQLite3 benchmark databases. The benchmark databases are
 created with ompl_benchmark_statistics library.

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_OPTIONS += nocheck
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CMAKE_FLAGS = \
#        -DCMAKE_VERBOSE_MAKEFILE=ON \
	-DOMPL_ODESOLVER=ON \
        -DOMPL_REGISTRATION=OFF \
	-DOMPL_BUILD_PYBINDINGS=ON \
	-DOMPL_BUILD_PYTESTS=OFF \
	-DPYTHON_EXEC=/usr/bin/python3

%:
	dh $@ --builddirectory=build --buildsystem=cmake --with python3

override_dh_clean:
ifneq ("$(wildcard $(build/bindings_generator.py))","")
	rm -rf py-bindings/ompl/bindings_generator.py*
	mv build/bindings_generator.py py-bindings/ompl/
endif
	rm -rf build

	find py-bindings/ -name *.pypp.*  | xargs -n1 rm -rf
	find py-bindings/ -name *.pyc  | xargs -n1 rm -rf
	find py-bindings/ -name *.so  | xargs -n1 rm -rf
	rm -rf doc/markdown/download.md doc/markdown/mainpage.md tests/resources/config.h CMakeModules/ompl.pc src/ompl/config.h
	dh_clean


override_dh_auto_configure:
	mkdir -p build
	dh_auto_configure --builddirectory=build -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS)

override_dh_auto_build:
# Uncomment this part to prepare the python bindings
#	cd build && $(MAKE) update_bindings
	cd build && $(MAKE)

override_dh_auto_install:
	dh_auto_install --builddirectory=build

override_dh_auto_test:
	echo "Supressing upstream tests"

## ompl 1.5.2%2Bds1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Boost 1.54 QUIET COMPONENTS unit_test_framework)
+find_package(Boost 1.58 QUIET COMPONENTS unit_test_framework)
 if(Boost_UNIT_TEST_FRAMEWORK_LIBRARY)
     option(OMPL_BUILD_TESTS "Build OMPL tests" ON)
 else()
@@ -6,22 +6,18 @@
 endif()
 add_feature_info(OMPL_BUILD_TESTS "${OMPL_BUILD_TESTS}" "Whether to build the unit tests.")
 
-# configure location of resources (which are used by some demos, so this needs
-# to be outside of if-statement below)
-file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
-if(WIN32)
-    # Correct directory separator for Windows
+if (OMPL_BUILD_TESTS)
+    file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
     string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR "${TEST_RESOURCES_DIR}")
-endif(WIN32)
-configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")
+    add_definitions(-DTEST_RESOURCES_DIR=\"${TEST_RESOURCES_DIR}\")
 
-if (OMPL_BUILD_TESTS)
     # Test datastructures implementation
+    add_ompl_test(test_adjacency_list datastructures/adjacency_list.cpp)
     add_ompl_test(test_heap datastructures/heap.cpp)
     add_ompl_test(test_grid datastructures/grid.cpp)
     add_ompl_test(test_gridb datastructures/gridb.cpp)
     add_ompl_test(test_nearestneighbors datastructures/nearestneighbors.cpp)
-    if(FLANN_FOUND)
+    if(flann_FOUND)
         target_link_libraries(test_nearestneighbors ${FLANN_LIBRARIES})
     endif()
     add_ompl_test(test_pdf datastructures/pdf.cpp)
@@ -34,6 +30,7 @@
     endif()
 
     # Test base code
+    add_ompl_test(test_halton_sampling base/halton_deterministic_sampling.cpp)
     add_ompl_test(test_state_operations base/state_operations.cpp)
     add_ompl_test(test_state_spaces base/state_spaces.cpp)
     add_ompl_test(test_state_storage base/state_storage.cpp)

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,8 @@
 Section: libs
 Priority: optional
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
-               dh-exec,
                libboost-date-time-dev,
                libboost-thread-dev,
                libboost-serialization-dev,
@@ -21,16 +20,17 @@
                libflann-dev,
 	       r-base-core,
 	       dh-python,
-	       python3-all
-Standards-Version: 4.5.0
+	       python3-all,
+	       dh-sequence-python3
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/ompl
 Vcs-Git: https://salsa.debian.org/science-team/ompl.git
-Homepage: http://ompl.kavrakilab.org
+Homepage: https://ompl.kavrakilab.org
 
 Package: libompl-dev
 Architecture: any
 Section: libdevel
-Depends: libompl15 (= ${binary:Version}),
+Depends: libompl16 (= ${binary:Version}),
          ${misc:Depends},
          libboost-dev,
          libeigen3-dev,
@@ -45,7 +45,7 @@
  additional components. This package contains the development files
  needed to use the library.
 
-Package: libompl15
+Package: libompl16
 Multi-Arch: same
 Architecture: any
 Depends: ${shlibs:Depends},
